VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit 'v1.0.11

'Types
    Private Type tSettings
        Name As String
        Value As String
    End Type
    
'Vars
    Public FileName As String

    Private SettingsCount As Long
    Private Settings() As tSettings

Function GetValue(iName As String, Optional iDefault As String = "") As String
    Dim A As Long
    Dim Temp As Long

    'Go through array and find value name
    For A = 0 To SettingsCount
        If Settings(A).Name = iName Then
            'Name found so return value
            GetValue = Settings(A).Value
            
            Exit Function
        End If
    Next
    
    'Return default
    GetValue = iDefault
End Function
Function LoadData(Optional iFileName As String = "") As Long
On Error GoTo 1

    Dim A As Long
    
    Dim Temp As Long
    Dim FileNumber As Long
    
    If Not iFileName = "" Then: FileName = iFileName
    
    Reset
    
    If Dir(FileName) = "" Then
        'Error: File doesn't exist
        LoadData = 0
        
        Exit Function
    End If

    'Load settings
    FileNumber = FreeFile
    Open FileName For Binary As #FileNumber
        Get FileNumber, , Temp
        SettingsCount = Temp
        ReDim Settings(SettingsCount + 1)
        
        For A = 0 To SettingsCount
            Get FileNumber, , Settings(A)
        Next
    Close #FileNumber
    
    LoadData = 1
    Exit Function
    
1  'Error
    Close FileNumber
End Function

Sub Reset()
    'Release memory
    SettingsCount = -1
    ReDim Settings(0)
End Sub
Function SaveData() As Long
On Error GoTo 1

    Dim A As Long
    Dim FileNumber As Integer
    
    If Not Dir(FileName) = "" Then: Kill FileName

    If SettingsCount > -1 Then
        'Save settings
        FileNumber = FreeFile
        Open FileName For Binary As #FileNumber
            Put FileNumber, , SettingsCount
            For A = 0 To SettingsCount
                Put FileNumber, , Settings(A)
            Next
        Close FileNumber
    End If
    
    SaveData = 1
    Exit Function
    
1  'Error
    Close FileNumber
End Function
Sub SetValue(iName As String, iValue As String)
    Dim A As Long

    'Go through array and find value name
    For A = 0 To SettingsCount
        If Settings(A).Name = iName Then
            'Name found so update value
            
            If iValue = "" Then
                'Delete settings
                Settings(A) = Settings(SettingsCount)
                
                SettingsCount = SettingsCount - 1
                If SettingsCount > -1 Then: ReDim Preserve Settings(SettingsCount)
                
            Else
                'Set value
                Settings(A).Value = iValue
            End If
            
            Exit Sub
        End If
    Next
    
    'Not found so create new settings
    SettingsCount = SettingsCount + 1
    ReDim Preserve Settings(SettingsCount)
    
    'Apply values
    Settings(SettingsCount).Name = iName
    Settings(SettingsCount).Value = iValue
End Sub

Private Sub Class_Initialize()
    SettingsCount = -1
    ReDim Settings(0)
End Sub


Private Sub Class_Terminate()
    SettingsCount = -1
    ReDim Settings(0)
End Sub


