Attribute VB_Name = "mMouse"
Option Explicit

'Types
    Type tMouse
        'Position
        x As Single
        y As Single
        
        'Size
        w As Long
        h As Long
        
        'Speed control
        SpeedX As Single
        SpeedY As Single
        
        'Game
        State As Long
        
        'Animation
        ActPhase As Long
        AniSpeed As Long
        LastTick As Long
    End Type
    
'Variables
    Public MouseCount As Long
    Public Mouse() As tMouse
    
    'Cursor
    Public MouseX As Long
    Public MouseY As Long
    
    Public MinMouseCount As Long
Sub Add()
    'Allocate memory
    MouseCount = MouseCount + 1
    ReDim Preserve Mouse(MouseCount)
    
    'Setup new mouse
    ResetMouse Mouse(MouseCount)
End Sub

Sub Animate()
    Dim A As Long
    Dim Temp As Long
    
    Temp = GetTickCount
    
    'Animate mice
    For A = 0 To MouseCount
        With Mouse(A)
            If .LastTick + .AniSpeed < Temp Then
                'Animate
                .LastTick = Temp
                
                .ActPhase = .ActPhase + 1
                If .ActPhase > 3 Then
                    'Last picture reached
                    .ActPhase = 0
                    
                    'Dead
                    If .State = 1 Then
                        AddPoints 10 + (.SpeedY), .x + .w / 2, .y + .h / 2
                        ResetMouse Mouse(A)
                    End If
                End If
            End If
        End With
    Next
End Sub

Sub Move()
    Dim A As Long
    
    For A = MouseCount To 0 Step -1
        'Apply movement
        With Mouse(A)
            .x = .x + .SpeedX
            .y = .y + .SpeedY
            
            If .State = 0 Then
                'If not dying
                If .y > ScreenH Then
                    'Mouse left screen
                    If Not GameOver Then
                        Missed = Missed + 1
                        AddPoints -Level, .x + .w / 2, CSng(ScreenH)
                    End If
                    
                    ResetMouse Mouse(A)
                End If
            End If
        End With
    Next
End Sub

Sub Draw()
    Dim A As Long
    
    'Background
    With Bitmap(BackBitmap)
        'Draw back
        BitBlt FrontDC, 0, 0, .w, .h - BackPos, .DC, 0, BackPos, vbSrcCopy
        BitBlt FrontDC, 0, .h - BackPos, .w, BackPos, .DC, 0, 0, vbSrcCopy
        
        'Move
        BackPos = BackPos + BackSpeed
        If BackPos >= .h Then: BackPos = 0
        
        'Increase speed as level increases
        If BackSpeed < Level Then: BackSpeed = BackSpeed + 0.1
        If BackSpeed > Level Then: BackSpeed = BackSpeed - 0.1
    End With
    
    For A = 0 To MouseCount
        'Draw mouse
        With Mouse(A)
            BitBlt FrontDC, .x, .y, .w, .h, Bitmap(MouseBitmap).DC, (.State * .w * 2) + .w, .ActPhase * .h, vbSrcPaint
            BitBlt FrontDC, .x, .y, .w, .h, Bitmap(MouseBitmap).DC, (.State * .w * 2), .ActPhase * .h, vbSrcAnd
        End With
    Next
End Sub

Sub Create()
    Dim A As Long
    
    'Allocate memory
    MouseCount = MinMouseCount 'Initial number of mice
    ReDim Mouse(MouseCount)
    
    For A = 0 To MouseCount
        'Setup mice
        ResetMouse Mouse(A)
    Next
End Sub

Sub Reset()
    'Release memory
    MouseCount = -1
    Erase Mouse
    
    Create
End Sub

Sub Initialize()
    'Init memory
    Reset
End Sub

Sub ResetMouse(iMouse As tMouse)
    With iMouse
        'Pre-defined size
        .w = 64
        .h = 64
        
        'Position
        .x = (ScreenW - Mouse(0).w) * Rnd
        .y = -.h
        
        'Speed control
        .SpeedX = 0
        .SpeedY = Level + (3 * Rnd) 'Randomize speed
        
        'Game
        .State = 0
        
        'Animation
        .ActPhase = 0
        .LastTick = GetTickCount
        .AniSpeed = 150 - (.SpeedY * 10) 'Faster movement > faster animation
    End With
End Sub

