Attribute VB_Name = "mText"
Option Explicit

'Consts
    Private Const TA_BASELINE = 24
    Private Const TA_CENTER = 6

'Declares
    Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
    Private Declare Function SetTextAlign Lib "gdi32" (ByVal hdc As Long, ByVal wFlags As Long) As Long
    Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long

'Types
    Type tText
        Enabled As Boolean
        
        'Position
        x As Single
        y As Single
        
        'Movement
        SpeedX As Single
        SpeedY As Single
        
        'General
        LifeTime As Long
        Caption As String
        Size As Long
        Color As Long
        
        Static As Boolean
    End Type
    
'Variables
    Public TextCount As Long
    Public Text() As tText
Sub Add(iText As String, iSize As Long, iX As Single, iY As Single, iColor As Long, iSpeedY As Single, Optional iStatic As Boolean = False)
    Dim Temp As Long
    
    Temp = Create
    
    With Text(Temp)
        .Caption = iText
        
        .Size = iSize
        
        .x = iX
        .y = iY
        
        .SpeedY = iSpeedY
        
        .LifeTime = 63
        .Color = iColor
        
        .Static = iStatic
    End With
End Sub

Sub CleanUp()
    Dim A As Long
    
    For A = TextCount To 0 Step -1
        If Text(A).Enabled = False Then
            mText.Remove A
        End If
    Next
End Sub

Function Create() As Long
    'Allocate memory
    TextCount = TextCount + 1
    If TextCount > UBound(Text, 1) Then: ReDim Preserve Text(TextCount)
    
    'Reset
    ResetText TextCount
    
    'Return index
    Create = TextCount
End Function


Sub Draw()
    Dim A As Long
    
    SetTextAlign FrontDC, TA_BASELINE Or TA_CENTER
    
    For A = 0 To TextCount
        With Text(A)
            If .Enabled Then
                SetTextColor FrontDC, .Color
                frmMain.Front.FontSize = IIf(.Static, .Size, (.LifeTime / 4) + 5)
                TextOut FrontDC, .x, .y, .Caption, Len(.Caption)
            End If
        End With
    Next
End Sub
Sub Initialize()
    'Count
    TextCount = -1
    
    Reset
End Sub

Sub Move()
    Dim A As Long
    
    For A = 0 To TextCount
        With Text(A)
            'Move
            .x = .x + .SpeedX
            .y = .y + .SpeedY
            
            'Decrease lifetime
            If Not .Static Then
                .LifeTime = .LifeTime - 1
                If .LifeTime < 0 Then: .Enabled = False
            End If
        End With
    Next
End Sub

Sub Remove(iText As Long)
    'Move last
    Text(iText) = Text(TextCount)
    
    'Decrease count
    TextCount = TextCount - 1
End Sub

Sub ResetText(iText As Long)
    With Text(iText)
        .Enabled = True
        
        'Position
        .x = 0
        .y = 0
        
        'Movement
        .SpeedX = 0
        .SpeedY = 0
        
        'General
        .LifeTime = 1
        .Caption = ""
        .Size = 12
    End With
End Sub

Sub Reset()
    Dim A As Long
    
    'Reset all
    For A = 0 To TextCount
        ResetText A
    Next
    
    'Count
    TextCount = -1
    
    'Release memory
    ReDim Text(0)
End Sub


Sub ShutDown()
    Reset

    'Free memory
    Erase Text
End Sub

